明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1422|回复: 0

[几何] 判断点是否在封闭多段线内【转载+优化】

[复制链接]
发表于 2021-10-22 14:33:12 | 显示全部楼层 |阅读模式
本帖最后由 qq1254582201 于 2021-10-22 14:41 编辑

一、使用多重多边形。使用函数AppendLoopFromBoundary(pline, true, tolerance)传入多段线范围线和容差创建多重多边形,然后根据函数IsPointInsideMPolygon((point, tolerance). Count返回值是否为1来判断是否在多段线内部。

二、使用Region和Brep,几乎所有的实体都适用于Region,通过Region.CreateFromCurves(curves)来创建Region,然后传入到Brep中,利用GetPointContainment(point, out result)返回的BrepEntity来判断是否是

Autodesk.AutoCAD.BoundaryRepresentation.Face,如果是,则最终为多段线内。

当然这里的解释表现得抽象了些,大家可以通过阅读代码来了解细节方面流程。值得注意的是在使用上面的函数时,必须导入acdbmgdbrep、AcMPolygonMGD两个dll动态链接库。可以说MPolygon具有一定的拓扑运算能力,可以弥补AutoCAD在几何拓扑运算方面的小小缺陷。当然了更多MPolygon有待进一步研究。
————————————————
版权声明:本文为CSDN博主「yGIS」的原创文章,遵循CC 4.0 BY-SA版权协议,转载请附上原文出处链接及本声明。
原文链接:https://blog.csdn.net/u010608964/article/details/82533064
  1. using Autodesk.AutoCAD.ApplicationServices;
  2. using Autodesk.AutoCAD.BoundaryRepresentation;
  3. using Autodesk.AutoCAD.DatabaseServices;
  4. using Autodesk.AutoCAD.EditorInput;
  5. using Autodesk.AutoCAD.Geometry;
  6. using Autodesk.AutoCAD.Runtime;
  7. using System;
  8. using System.Collections.Generic;
  9. using System.Linq;
  10. using System.Text;

  11. namespace IsInPolyline
  12. {
  13.     public class Class1
  14.     {
  15.         
  16.         [CommandMethod("pinpt1")]
  17.         public static void test()
  18.         {
  19.             Document doc = Application.DocumentManager.MdiActiveDocument;
  20.             Database db = doc.Database;
  21.             Editor ed = doc.Editor;

  22.             PromptEntityOptions peo = new PromptEntityOptions("\n选择一条多段线: ");
  23.             peo.SetRejectMessage("Only a polyline !");
  24.             peo.AddAllowedClass(typeof(Polyline), true);
  25.             PromptEntityResult per = ed.GetEntity(peo);
  26.             if (per.Status != PromptStatus.OK)
  27.                 return;

  28.             using (Transaction tr = db.TransactionManager.StartOpenCloseTransaction())
  29.             {
  30.                 Polyline pline = (Polyline)tr.GetObject(per.ObjectId, OpenMode.ForRead);
  31.                 PromptPointOptions ppo = new PromptPointOptions("\n拾取一个点 <quit>: ");
  32.                 ppo.AllowNone = true;
  33.                 while (true)
  34.                 {
  35.                     PromptPointResult ppr = ed.GetPoint(ppo);
  36.                     if (ppr.Status != PromptStatus.OK)
  37.                         break;
  38.                     Application.ShowAlertDialog(
  39.                         pline.IsPointInside(ppr.Value) ? "Inside" : "Outside");
  40.                 }
  41.                
  42.             }
  43.         }

  44.         [CommandMethod("pinpt2")]
  45.         public void test2() {
  46.             Document doc = Application.DocumentManager.MdiActiveDocument;
  47.             Database db = doc.Database;
  48.             Editor ed = doc.Editor;

  49.             PromptEntityOptions peo = new PromptEntityOptions("\n选择一条多段线: ");
  50.             peo.SetRejectMessage("Only a polyline !");
  51.             peo.AddAllowedClass(typeof(Polyline), true);
  52.             PromptEntityResult per = ed.GetEntity(peo);
  53.             if (per.Status != PromptStatus.OK)
  54.                 return;
  55.             using (Transaction tr = db.TransactionManager.StartOpenCloseTransaction())
  56.             {
  57.                  Polyline pline = (Polyline)tr.GetObject(per.ObjectId, OpenMode.ForRead);
  58.                  if (!pline.Closed)
  59.                  {
  60.                      ed.WriteMessage("\n多段线必须为闭合");
  61.                      return;
  62.                  }
  63.                  DBObjectCollection curves = new DBObjectCollection();
  64.                  curves.Add(pline);
  65.                  try
  66.                  {
  67.                      using (DBObjectCollection regions = Region.CreateFromCurves(curves))
  68.                      using (Region region = (Region)regions[0])
  69.                      {
  70.                           PromptPointOptions ppo = new PromptPointOptions("\nPick a point <quit>: ");
  71.                           ppo.AllowNone = true;
  72.                           while (true)
  73.                           {
  74.                               PromptPointResult ppr = ed.GetPoint(ppo);
  75.                               if (ppr.Status != PromptStatus.OK)
  76.                                   break;
  77.                               Application.ShowAlertDialog(
  78.                                                   GetPointContainment(region, ppr.Value).ToString());
  79.                           }
  80.                      }
  81.                  }
  82.                  catch (System.Exception exn)
  83.                  {

  84.                      ed.WriteMessage("\nError: " + exn.Message);
  85.                  }
  86.             }
  87.         }

  88.         private PointContainment GetPointContainment(Region region, Point3d point)
  89.         {
  90.             PointContainment result = PointContainment.Outside;
  91.             using (Brep brep = new Brep(region))
  92.             {
  93.                 if (brep != null)
  94.                 {
  95.                     using (BrepEntity ent = brep.GetPointContainment(point, out result))
  96.                     {
  97.                         if (ent is Autodesk.AutoCAD.BoundaryRepresentation.Face)
  98.                         {
  99.                             result = PointContainment.Inside;
  100.                         }
  101.                     }
  102.                 }
  103.             }
  104.             return result;
  105.         }
  106.     }
  107. }
以上是原作者的代码。但是方法一缺少了重要的pline.IsPointInside(pt),以下为自己东拼西凑的:IsPointInside(this Polyline pline, Point3d pt)
  1. public static bool IsPointInside(this Polyline pline, Point3d pt)
  2.         {
  3.             bool str = true;
  4.             Document doc = Application.DocumentManager.MdiActiveDocument;
  5.             Database db = doc.Database;
  6.             Editor ed = doc.Editor;
  7.             using (var tr = db.TransactionManager.StartTransaction())
  8.             {
  9.                 var btr = (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite);
  10.                 var mPolygon = new MPolygon();
  11.                 btr.AppendEntity(mPolygon);
  12.                 tr.AddNewlyCreatedDBObject(mPolygon, true);
  13.                 mPolygon.UpgradeOpen();
  14.                 if (pline is Polyline)
  15.                     mPolygon.AppendLoopFromBoundary((Polyline)pline, true, 1E-12);
  16.                 mPolygon.ColorIndex = 1;
  17.                 mPolygon.DowngradeOpen();
  18.                 var jj = mPolygon.IsPointInsideMPolygon(pt, 1E-12).Count;
  19.                 if (jj != 1)
  20.                 {
  21.                     str = false;
  22.                 }
  23.                 //tr.Commit();
  24.             }
  25.             return str;
  26.         }




评分

参与人数 1金钱 +20 收起 理由
canghaiyishu + 20

查看全部评分

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-22 14:58 , Processed in 0.171861 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表